// rddeclnt.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <windows.h>

#include "mainfrm.h"
#include "rddecdoc.h"
#include "rddecvw.h"
#include "rddeclnt.h"

#include "rddedlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRddeclntApp

BEGIN_MESSAGE_MAP(CRddeclntApp, CWinApp)
	//{{AFX_MSG_MAP(CRddeclntApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRddeclntApp construction

CRddeclntApp::CRddeclntApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
    dwDDEInst = 0;
    hConv = 0;
    hConvList = 0;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRddeclntApp object

CRddeclntApp NEAR theApp;
// Pointer to the only document
CRddeclntDoc* pDocument;
//Pointer to the only view
CRddeclntView* pView;
 
/////////////////////////////////////////////////////////////////////////////
// CRddeclntApp initialization

BOOL CRddeclntApp::InitInstance()
{
   // Standard initialization
   // If you are not using these features and wish to reduce the size
   //  of your final executable, you should remove from the following
   //  the specific initialization routines you do not need.

   SetDialogBkColor();        // Set dialog background color to gray
   LoadStdProfileSettings();  // Load standard INI file options (including MRU)

   // Register the application's document templates.  Document templates
   //  serve as the connection between documents, frame windows and views.

   CSingleDocTemplate* pDocTemplate;
   pDocTemplate = new CSingleDocTemplate(
                             IDR_MAINFRAME,
                             RUNTIME_CLASS(CRddeclntDoc),
                             RUNTIME_CLASS(CMainFrame),     // main SDI frame window
                             RUNTIME_CLASS(CRddeclntView));
   AddDocTemplate(pDocTemplate);
 
   // Initialize DDEML
   DdeInitialize(&dwDDEInst, CRddeclntDoc::DDECallback, APPCMD_CLIENTONLY, 0);

   // create a new (empty) document
   OnFileNew();

   if (m_lpCmdLine[0] != '\0')
   {
      // TODO: add command line processing here
   }


   return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CRddeclntApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

            
int CRddeclntApp::ExitInstance() 
{
// Uninitialize DDEML
   pDocument->AbandonDDE();

   if ( hConvList )
      DdeDisconnectList(hConvList);

   DdeUninitialize(dwDDEInst);	
   return CWinApp::ExitInstance();
}

