// rddedlg.cpp : implementation file
//

#include "stdafx.h"

#include "rddecdoc.h"
#include "rddecvw.h"
#include "rddeclnt.h"
#include "rddedlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRDDEDlg dialog


CRDDEDlg::CRDDEDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRDDEDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRDDEDlg)
	m_Item = "";
	m_Service = "";
	m_MessageBoxes = FALSE;
	//}}AFX_DATA_INIT
}

void CRDDEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRDDEDlg)
	DDX_CBString(pDX, IDC_ITEM, m_Item);
	DDV_MaxChars(pDX, m_Item, 100);
	DDX_CBString(pDX, IDC_SERVICE, m_Service);
	DDV_MaxChars(pDX, m_Service, 100);
	DDX_Check(pDX, IDC_CHECK1, m_MessageBoxes);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRDDEDlg, CDialog)
	//{{AFX_MSG_MAP(CRDDEDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CRDDEDlg message handlers

BOOL CRDDEDlg::OnInitDialog()
{
   CDialog::OnInitDialog();
	
   // TODO: Add extra initialization here
   // Initialize contents of the dialog

   DWORD dwDDEInst = theApp.dwDDEInst;

   CComboBox *pCB = (CComboBox*)GetDlgItem(IDC_SERVICE);
   CComboBox *pCBItem = (CComboBox*)GetDlgItem(IDC_ITEM);
   CButton *pCButton = (CButton*)GetDlgItem(IDC_CHECK1);
   pCButton->SetCheck(pDocument->m_MessageBoxes);

   if ( theApp.hConvList )
      DdeDisconnectList(theApp.hConvList);

// Disconnect and existing conversation if needed
   pDocument->AbandonDDE();

   theApp.hConvList = DdeConnectList(dwDDEInst,
                           NULL, // Any service
                           NULL, // Any topic
                           NULL, // New conversation list
                           NULL);// Default context 

// Walk through the returned list and fill in the Service list
    if(theApp.hConvList)
    {
        HCONV hConv = NULL;
        HCONV ConvList[100] = {0};
        int ConvCount = 0;
        int i = 0;
        CONVINFO cinfo;
        cinfo.cb = sizeof(CONVINFO);
        char buf[256];
        char Name[100];

        while (hConv = DdeQueryNextServer(theApp.hConvList, hConv)) 
        {

           UINT status = DdeQueryConvInfo(hConv,QID_SYNC,
                                          &cinfo);

           /* Make a list of the conv handles */
           ConvList[ConvCount++] = hConv;

// Get the name of the server and topic
           DdeQueryString(dwDDEInst, cinfo.hszSvcPartner,
                          buf, sizeof(buf), CP_WINANSI);
           DdeQueryString(dwDDEInst, cinfo.hszTopic,
                          Name, sizeof(Name), CP_WINANSI);

// Add the names to the service list as long as both not empty
           if ( buf[0] != 0 && Name[0] != 0 )
           {
              strcat( buf, "|" );
              strcat( buf, Name );
              pCB->AddString(buf);
           }
       }

// Add all the standard system topic items
        pCBItem->AddString(SZDDESYS_TOPIC);
        pCBItem->AddString(SZDDESYS_ITEM_TOPICS);
        pCBItem->AddString(SZDDESYS_ITEM_SYSITEMS);
        pCBItem->AddString(SZDDESYS_ITEM_RTNMSG);
        pCBItem->AddString(SZDDESYS_ITEM_STATUS);
        pCBItem->AddString(SZDDESYS_ITEM_FORMATS); 
        pCBItem->AddString(SZDDESYS_ITEM_HELP); 
        pCBItem->AddString(SZDDE_ITEM_ITEMLIST);
         
/* Close all conversations 
#if 0
        DdeDisconnectList(theApp.hConvList);
#else
        for ( i = 0; i < ConvCount; i++ )
           DdeDisconnect( ConvList[i] );
#endif
*/

// Select PROGMAN as the default service
        if(pCB->SelectString(0, "Progman") != CB_ERR)
        {
// Add topic "progman" and item "groups"
            CComboBox *pCBT = (CComboBox*)
                              GetDlgItem(IDC_SERVICE);
            pCBT->AddString("Progman|Progman");
            pCBT->SetCurSel(0);

            pCBT = (CComboBox*)GetDlgItem(IDC_ITEM);
            pCBT->AddString("Groups");
            pCBT->SetCurSel(0);
        }
    }

    pCB->SetFocus();
    return FALSE;  // return TRUE  unless you set the focus to a control
}
